// Catfish automatic supers maker - 1.0
// Takes the content of a text file and a selected comp. 
// Then duplicates the comp, replacing the content of the top two layers based on the contents of the text file.
// The two layers are delineated in the text file by a ";"
// 
// Have to excuse the mess. I am definitely NOT a programmer. 
// Steve - steven at catfish.net.au

// A lot of the content here was stolen wholesale from Dan Ebberts totall awesome website www.motionscript.com



{
	// create undo group
	app.beginUndoGroup("Automatic Supers Maker");
	
	var compHeader = "Super-";
	var myFile = fileGetDialog("Select a text file to open.","");                                           //  Select a file to open

	if (myFile != null){
		var proj = app.project; 
		var fileOK = myFile.open("r","TEXT","????");															// Check the file opens ok, and is a text file.
		if (fileOK){
			if(proj) {																										// Check we have a project open.
				var activeItem = proj.activeItem;
				if (activeItem != null && (activeItem instanceof CompItem)){						// Check that we have a comp selected.
					var testCompLayer1 = activeItem.layer(1);												// grab the two layers in question so we can test them
					var testCompLayer2 = activeItem.layer(2);
					var testCompLayer3 = activeItem.layer(3);
					if (testCompLayer1.matchName=="ADBE Text Layer" && testCompLayer2.matchName=="ADBE Text Layer" && testCompLayer3.matchName=="ADBE Text Layer") {				// check that the template comp has two text layers at the top.
						
						var templateComp = activeItem;															
						var thisComp = templateComp;
						var text;
						var ind = 1;
						
						
						while (!myFile.eof){
							thisComp = templateComp.duplicate();												// Duplicate the template comp
							
							text = myFile.readln();																	// read the next line of the csv
							if (text == "") text = "\r" ;																// I'm assuming this is to deal with the difference between Mac window linefeeds? Dunno I lifted it.
							var thisSuper = new Array;
							thisSuper = ParseLine(text, compHeader);											// turn the data from that line into my new super format
							
						
							var upperTextLayer = thisComp.layer(1);											// grab the two layers in question 
							var midleTextLayer = thisComp.layer(2);
							var lowerTextLayer = thisComp.layer(3);

							upperTextLayer.property("Source Text").setValue(thisSuper[0]);			// change the text on said layers
							midleTextLayer.property("Source Text").setValue(thisSuper[1]);
							lowerTextLayer.property("Source Text").setValue(thisSuper[2]);
						
							thisComp.name = "L3RD-" + ind;														// rename the Composition
							ind++;
			
						}
					} else { alert("Doesn't seem that the comp is properly formatted") }
				} else { alert("No template comp selected or multiple comp's selected"); }
			} else { alert("No project open"); }
			myFile.close();
		}else{ alert("File open failed!"); }
	}else{ alert("No text file selected."); }
	app.endUndoGroup();
}


function ParseLine (textString, compHeader) {
		var lineArray = text.split(";");   // get the two parts of the Super
		var topLine = lineArray[0];
		var midleLine = lineArray[1];
		var bottomLine = lineArray[2];
		var compName = "";
	
		// ok so this part is designed to take the first part of the super and condense it into a compact, but easy to read name for the comp - that's (hopefully) legal as a filename.
		// eg:  Steven NICHOLSON & paul ANDerSON becomes StevenNicholson+PaulAnderson
			
		//Get rid spaces. And capitalize each word
		
		var strings;
		strings = topLine.split(" ");
		var firstLetter, restOfWord,x;
		for (x in strings)
		{
		firstLetter = strings[x].substr(0,1);
		restOfWord = strings[x].substr(1, strings[x].length-1);
		compName+=firstLetter.toUpperCase() + restOfWord.toLowerCase();
		}		
		
		// Turn ampersands into '+'
		 		
		compName = compName.replace("&", "+");

		// Strip everything else.

		compName = compName.replace(/[^a-zA-Z0-9\-\+]/g, "");
		

		// Limit the length of the comp name
		compName = compName.slice(0, 32 - compHeader.length);
		compName= compHeader + compName;
		var returnData = new Array(topLine, midleLine, bottomLine, compName);
		return returnData;
}


